#include "AlphaBeta.h"
#include "Global.h"
#include "Definitions.h"

int countAB=0; // nombre de nodes parcourues pf>=0
int countTables=0; // nombre de coupes tables de transpo
// pour programmeur:
bool heurist_floorpp=false;

/* eventuellement plus tard passer un nouveau parametre au programme donnant l'etat des 50 coups;
pas urgent : affecte tres peu le jeu  */

/************************************************************************
* fonctions appelant les alpha-beta sur chaque coup possible, puis choix
*************************************************************************/

Coup AlphaBeta::coupAB_W() { 

	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn;

	prof=1;
	stopped=false;
	float eval,best_eval; // evaluations courante et meilleure
	Coup meilleur_coup=Coup(0,0); // le meilleur coup trouve jusqu'alors
	// iterative deepening: on stocke les coups avec leur evaluation 
	std::vector<EvalCoupW> ordered_movesW;

	findAllW(); 
	VectorMoves coups;
	coups.copie(setCoupsW);

	// shortcut
	if (coups.size()==1) {
		coups[0].prb=(coups[0].prb && memPrb);
		coups[0].prn=(coups[0].prn && memPrn);
		coups[0].grb=(coups[0].grb && memGrb);
		coups[0].grn=(coups[0].grn && memGrn);
		return coups[0];
	}
	
	// test de mat/pat
	if (coups.empty()) {
		if (underCheckWM_W()) return Coup(0,0);
		else return Coup(56,56);
	}

	while (true) { 

		best_eval=MIN;
		// au premier passage on cherche les coups possibles en memorisant leurs evaluations
		if (prof==1) { 
	  
			// parcours des coups, evaluation	
			for (int i=coups.size()-1; i>=0; i--) { 
		
				// actualisation des flags
				coups[i].prb=(coups[i].prb && memPrb);
				coups[i].prn=(coups[i].prn && memPrn);
				coups[i].grb=(coups[i].grb && memGrb);
				coups[i].grn=(coups[i].grn && memGrn);

				lastMove.ep=(coups[i].enPassant>=0);
				lastMove.prb=coups[i].prb;
				lastMove.prn=coups[i].prn;
				lastMove.grb=coups[i].grb;
				lastMove.grn=coups[i].grn;
				lastMove.dep=coups[i].dep;
				lastMove.arr=coups[i].arr;

				plateau.moveW(coups[i]); 
				eval=alphaBetaB(0,MIN,MAX);
				
				// shortcut: si on mate avec ce coup, on s'arrete
				if (eval>=MAX) return coups[i];

				ordered_movesW.push_back(EvalCoupW(coups[i],eval));
			
				if (eval>best_eval) { 
					best_eval=eval;
					meilleur_coup=ordered_movesW.back().cp;
				} 
				else if (eval==best_eval) meilleur_coup=ordered_movesW.back().cp;

				plateau.undoW(coups[i]);
			} 
		
			// on prepare ordered_moves pour l'iteration suivante (avec ordre non forcement conserve)
			sort(ordered_movesW.begin(),ordered_movesW.end());
		}   
		else { 

			int nb=0; // nombre de coups ne menant pas au mat
			firstMove=true;
			secondMove=false;
			int count=0,fpp;
			// temps utilise pour les tous premiers coups de l'etage
			float fTime,sTime,check_time;

			// initialisation des repetitions et ajout de la position courante
			repetPosW=(int*)malloc((prof+1)*sizeof(int));
			repetPosB=(int*)malloc((prof+1)*sizeof(int));
			for (int i=prof-1; i>=0; i--) {
				repetPosW[i]=-1;
				repetPosB[i]=-1;
			}
			repetPosW[prof]=plateau.cle().keyB; 

			// parcours direct des coups possibles (cette fois on les connait)
			for (int i=coups.size()-1; i>=0; i--) { 

				// cas d'arret time_over	
				if (tim.elapsed()>=tmp || (count>=2 && tmp-tim.elapsed()<sTime) 
					|| (count>=1 && tmp-tim.elapsed()<0.667*fTime)) stopped=true;

				if (stopped) return meilleur_coup;

				if (ordered_movesW[i].eval<=MIN) continue; // on ne regarde pas les coups ou on se fait mater
				nb++;
				check_time=tim.elapsed();

				// actualisation du dernier coup + flags
				lastMove.ep=(ordered_movesW[i].cp.enPassant>=0);
				lastMove.prb=memPrb && ordered_movesW[i].cp.prb;
				lastMove.prn=memPrn && ordered_movesW[i].cp.prn;
				lastMove.grb=memGrb && ordered_movesW[i].cp.grb;
				lastMove.grn=memGrn && ordered_movesW[i].cp.grn;
				lastMove.dep=ordered_movesW[i].cp.dep;
				lastMove.arr=ordered_movesW[i].cp.arr;

				plateau.moveW(ordered_movesW[i].cp);
				
				if (heurist_floorpp) {
					// si tres bonne eval, on regarde tout (moins de coupes mais evite bouclages)
					if (prof<=3) {
						if (best_eval>2) eval=alphaBetaB(prof-1-floorpp(best_eval-ordered_movesW[i].eval),MIN,MAX);
						else eval=alphaBetaB(prof-1-floorpp(best_eval-ordered_movesW[i].eval),best_eval,MAX);
					}
					else {
						fpp=floorpp(best_eval-ordered_movesW[i].eval);
						if (best_eval>2) {
							if (fpp>1) eval=alphaBetaB(prof-1-fpp,MIN,MAX);
							else if (fpp>0) eval=alphaBetaProf_2B(MIN,MAX);
							else eval=alphaBetaProf_1B(MIN,MAX);
						}
						else {
							if (fpp>1) eval=alphaBetaB(prof-1-fpp,best_eval,MAX);
							else if (fpp>0) eval=alphaBetaProf_2B(best_eval,MAX);
							else eval=alphaBetaProf_1B(best_eval,MAX);
						}
					}
				}
				
				else { // cas sans heuristique rapide mais douteuse.. :
					eval=alphaBetaProf_1B(best_eval,MAX);
				}

				// shortcut: si on mate avec ce coup, on s'arrete
				if (eval>=MAX) return ordered_movesW[i].cp;
				
				if (stopped) return meilleur_coup;
				
				// actualisation de ordered_movesW
				ordered_movesW[i].eval=eval;
					
				if (eval>best_eval) { 
					best_eval=eval;
					meilleur_coup=ordered_movesW[i].cp;
				}
				
				plateau.undoW(ordered_movesW[i].cp);

				// mise a jour des booleens de controle de temps et du compteur
				if (count==0) {
					firstMove=false;
					secondMove=true;
					fTime=tim.elapsed()-check_time;
				}
				else if (count==1) {
					secondMove=false;
					sTime=tim.elapsed()-check_time;
				}
				count++;
			}
			
			// on prepare ordered_moves pour l'iteration suivante
			tri_ordonneW(ordered_movesW);
			
			// on libere repetPos
			free(repetPosW);
			free(repetPosB);
		} 
		prof++;
	}
	return Coup(); // on n'arrive jamais la
}

Coup AlphaBeta::coupAB_B() {   

	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn;

	prof=1;
	stopped=false;
	float eval,best_eval; // evaluations courante et meilleures
	Coup meilleur_coup=Coup(0,0); // le meilleur coup trouve jusqu'alors
	// iterative deepening: on stocke les coups avec leur evaluation 
	std::vector<EvalCoupB> ordered_movesB;

	findAllB();
	VectorMoves coups;
	coups.copie(setCoupsB);

	// shortcut
	if (coups.size()==1) {
		coups[0].prb=(coups[0].prb && memPrb);
		coups[0].prn=(coups[0].prn && memPrn);
		coups[0].grb=(coups[0].grb && memGrb);
		coups[0].grn=(coups[0].grn && memGrn);
		return coups[0];
	}

	// test de mat/pat
	if (coups.empty()) {
		if (underCheckWM_B()) return Coup(0,0);
		else return Coup(56,56);
	}

	while (true) { 

		best_eval=MAX;     
		// au premier passage on cherche les coups possibles en memorisant leurs evaluations
		if (prof==1) {
							
			// parcours des coups, evaluation	
			for (int i=coups.size()-1; i>=0; i--) {	
		
				// actualisation des flags
				coups[i].prb=(coups[i].prb && memPrb);
				coups[i].prn=(coups[i].prn && memPrn);
				coups[i].grb=(coups[i].grb && memGrb);
				coups[i].grn=(coups[i].grn && memGrn);

				lastMove.ep=(coups[i].enPassant>=0);
				lastMove.prb=coups[i].prb;
				lastMove.prn=coups[i].prn;
				lastMove.grb=coups[i].grb;
				lastMove.grn=coups[i].grn;
				lastMove.dep=coups[i].dep;
				lastMove.arr=coups[i].arr;
		
				plateau.moveB(coups[i]);
				eval=alphaBetaW(0,MIN,MAX); 
				
				// shortcut: si on mate avec ce coup, on s'arrete
				if (eval<=MIN) return coups[i];
				
				ordered_movesB.push_back(EvalCoupB(coups[i],eval));

				if (eval<best_eval) {
					best_eval=eval;
					meilleur_coup=ordered_movesB.back().cp;
				}  
				else if (eval==best_eval) meilleur_coup=ordered_movesB.back().cp;
				
				// pas de coupure beta possible ici (on remplit ordered_moves)
				plateau.undoB(coups[i]); 
			} 

			// on prepare ordered_moves pour l'iteration suivante (avec ordre non forcement conserve)
			sort(ordered_movesB.begin(),ordered_movesB.end()); 
		}   
		else { 

			int nb=0; // nombre de coups ne menant pas au mat
			firstMove=true;
			secondMove=false;
			int count=0,fpp;
			// temps utilise pour les tous premiers coups de l'etage
			float fTime,sTime,check_time;

			// initialisation des repetitions et ajout de la position courante
			repetPosW=(int*)malloc((prof+1)*sizeof(int));
			repetPosB=(int*)malloc((prof+1)*sizeof(int));
			for (int i=prof-1; i>=0; i--) {
				repetPosW[i]=-1;
				repetPosB[i]=-1;
			}
			repetPosB[prof]=plateau.cle().keyB; 

			// parcours direct des coups possibles (cette fois on les connait)
			for (int i=coups.size()-1; i>=0; i--) {

				// cas d'arret time_over	
				if (tim.elapsed()>=tmp || (count>=2 && tmp-tim.elapsed()<sTime) 
					|| (count>=1 && tmp-tim.elapsed()<0.667*fTime)) stopped=true;

				if (stopped) return meilleur_coup;	

				if (ordered_movesB[i].eval>=MAX) continue; // on ne regarde pas les coups ou on se fait mater
				nb++;
				check_time=tim.elapsed();

				// actualisation du dernier coup + flags
				lastMove.ep=(ordered_movesB[i].cp.enPassant>=0);
				lastMove.prb=memPrb && ordered_movesB[i].cp.prb;
				lastMove.prn=memPrn && ordered_movesB[i].cp.prn;
				lastMove.grb=memGrb && ordered_movesB[i].cp.grb;
				lastMove.grn=memGrn && ordered_movesB[i].cp.grn;
				lastMove.dep=ordered_movesB[i].cp.dep;
				lastMove.arr=ordered_movesB[i].cp.arr;

				plateau.moveB(ordered_movesB[i].cp);
	
				if (heurist_floorpp) {
					// si tres bonne eval, on regarde tout (moins de coupes mais evite bouclages)
					if (prof<=3) {
						if (best_eval<-2) eval=alphaBetaW(prof-1-floorpp(ordered_movesB[i].eval-best_eval),MIN,MAX);
						else eval=alphaBetaW(prof-1-floorpp(ordered_movesB[i].eval-best_eval),MIN,best_eval);
					}
					else {
						fpp=floorpp(ordered_movesB[i].eval-best_eval);
						if (best_eval<-2) {
							if (fpp>1) eval=alphaBetaW(prof-1-fpp,MIN,MAX);
							else if (fpp>0) eval=alphaBetaProf_2W(MIN,MAX);
							else eval=alphaBetaProf_1W(MIN,MAX);
						}
						else {
							if (fpp>1) eval=alphaBetaW(prof-1-fpp,MIN,best_eval);
							else if (fpp>0) eval=alphaBetaProf_2W(MIN,best_eval);
							else eval=alphaBetaProf_1W(MIN,best_eval);
						}
					}
				}
				
				else { // cas "normal" :
					eval=alphaBetaProf_1W(MIN,best_eval);
				}

				// shortcut: si on mate avec ce coup, on s'arrete
				if (eval<=MIN) return ordered_movesB[i].cp;
				
				if (stopped) return meilleur_coup;	
				
				// actualisation de ordered_movesB
				ordered_movesB[i].eval=eval;

				if (eval<best_eval) {
					best_eval=eval;
					meilleur_coup=ordered_movesB[i].cp;
				}
				
				plateau.undoB(ordered_movesB[i].cp); 

				// mise a jour des booleens de controle de temps et du compteur
				if (count==0) {
					firstMove=false;
					secondMove=true;
					fTime=tim.elapsed()-check_time;
				}
				else if (count==1) {
					secondMove=false;
					sTime=tim.elapsed()-check_time;
				}
				count++;	
			}
			
			// on prepare ordered_moves pour l'iteration suivante
			tri_ordonneB(ordered_movesB);
			
			// on libere repetPos
			free(repetPosW);
			free(repetPosB);
		} 
		prof++;
	} 
	return Coup(); // on n'arrive jamais la
}

/************************
* les alpha-beta prof-1
*************************/    
    
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote blanc)
float AlphaBeta::alphaBetaProf_1W(float A,float B) {

	countAB++;

	// calcul de la signature du plateau
	Clefs cfs=plateau.cle();
	// ajout de la position
	repetPosW[prof-1]=cfs.keyB;

	findAllW();
	VectorMoves coups;
	coups.copie(setCoupsW);

	if (coups.empty()) { 
		repetPosW[prof-1]=-1;
		if (check || sCheck>=0) return MIN;
		return 0;
	}
		
	float eval,alpha=MIN,bInf=A;
	int fpp;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;
	
	// pour des profondeurs entre prof et prof-2, on reordonne les coups suivant leur evaluation a pf==1,
	avLMove.dep=lastMove.dep;
	avLMove.arr=lastMove.arr;
	avLMove.ep=memEp;

	std::vector<ValIndiceW> aux(coups.size());
	for (int i=coups.size()-1; i>=0; i--) {
		plateau.moveW(coups[i]);
		lastMove.ep=(coups[i].enPassant>=0);
		lastMove.prb=memPrb && coups[i].prb;
		lastMove.prn=memPrn && coups[i].prn;
		lastMove.grb=memGrb && coups[i].grb;
		lastMove.grn=memGrn && coups[i].grn;
		lastMove.dep=coups[i].dep;
		lastMove.arr=coups[i].arr;
		aux[i].indice=i;
		aux[i].eval=alphaBetaB(1,MIN,MAX);
		plateau.undoW(coups[i]);	
	}
	sort(aux.begin(),aux.end());
		
	for (int i=coups.size()-1; i>=0; i--) {	

		plateau.moveW(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0); 
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;

		fpp=floorpp(alpha-aux[i].eval);
		if (heurist_floorpp && fpp>0) eval=alphaBetaB(prof-2-fpp,bInf,B);
		else eval=alphaBetaProf_2B(bInf,B);
		if (eval>alpha) {
			alpha=eval;
			if (alpha>A) bInf=alpha;
		} 
		if (alpha>=B) { 
			plateau.undoW(coups[aux[i].indice]);
			// stockage de l'evaluation
			if (tailleTablesW<TAILLE_MAX) { 
				bestProfW[cfs.keyB].push_back(prof-1,alpha,cfs.keyR);	
				tailleTablesW++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosW[prof-1]=-1;
			return alpha;
		}
		plateau.undoW(coups[aux[i].indice]);
	}
			
	// stockage de l'evaluation
	if (tailleTablesW<TAILLE_MAX) { 
		bestProfW[cfs.keyB].push_back(prof-1,alpha,cfs.keyR);	
		tailleTablesW++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosW[prof-1]=-1; 
	return alpha;
}
     
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote noir)
float AlphaBeta::alphaBetaProf_1B(float A,float B) {	

	countAB++; 

	// calcul de la signature du plateau
	Clefs cfs=plateau.cle();
	// ajout de la position
	repetPosB[prof-1]=cfs.keyB;

	findAllB();
	VectorMoves coups;
	coups.copie(setCoupsB);

	if (coups.empty()) {
		repetPosB[prof-1]=-1; 
		if (check || sCheck>=0) return MAX;
		return 0;
	}

	float eval,beta=MAX,bSup=B;
	int fpp;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;

	// pour des profondeurs entre prof et prof-2, on reordonne les coups suivant leur evaluation a pf==1
	avLMove.dep=lastMove.dep;
	avLMove.arr=lastMove.arr;
	avLMove.ep=memEp;
                 
	std::vector<ValIndiceB> aux(coups.size());
	for (int i=coups.size()-1; i>=0; i--) {
		plateau.moveB(coups[i]);
		lastMove.ep=(coups[i].enPassant>=0);
		lastMove.prb=memPrb && coups[i].prb;
		lastMove.prn=memPrn && coups[i].prn;
		lastMove.grb=memGrb && coups[i].grb;
		lastMove.grn=memGrn && coups[i].grn;
		lastMove.dep=coups[i].dep;
		lastMove.arr=coups[i].arr;
		aux[i].indice=i;
		aux[i].eval=alphaBetaW(1,MIN,MAX);
		plateau.undoB(coups[i]);
	}
	sort(aux.begin(),aux.end());

	for (int i=coups.size()-1; i>=0; i--) {	

		plateau.moveB(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0); 
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;

		fpp=floorpp(aux[i].eval-beta);
		if (heurist_floorpp && fpp>0) eval=alphaBetaW(prof-2-fpp,A,bSup);
		else eval=alphaBetaProf_2W(A,bSup);
		if (eval<beta) {
			beta=eval;
			if (beta<B) bSup=beta;
		} 
		if (A>=beta) { 
			plateau.undoB(coups[aux[i].indice]);
			// stockage de l'evaluation 
			if (tailleTablesB<TAILLE_MAX) { 
				bestProfB[cfs.keyB].push_back(prof-1,beta,cfs.keyR);	
				tailleTablesB++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosB[prof-1]=-1;
			return beta;
		}
		plateau.undoB(coups[aux[i].indice]);
	}
	// stockage de l'evaluation 
	if (tailleTablesB<TAILLE_MAX) { 
		bestProfB[cfs.keyB].push_back(prof-1,beta,cfs.keyR);	
		tailleTablesB++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosB[prof-1]=-1;
	return beta;
}

/************************
* les alpha-beta prof-2
*************************/    
    
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote blanc)
float AlphaBeta::alphaBetaProf_2W(float A,float B) {

	if (secondMove) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}

	countAB++;

	// calcul de la signature du plateau
	Clefs cfs=plateau.cle();
	// ajout de la position
	repetPosW[prof-2]=cfs.keyB;

	findAllW();
	VectorMoves coups;
	coups.copie(setCoupsW);

	if (coups.empty()) {
		repetPosW[prof-2]=-1;
		if (check || sCheck>=0) return MIN;
		return 0;
	}
		
	float eval,alpha=MIN,bInf=A;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;
	
	// pour des profondeurs entre prof et prof-2, on reordonne les coups suivant leur evaluation a pf==1,
	avLMove.dep=lastMove.dep;
	avLMove.arr=lastMove.arr;
	avLMove.ep=memEp;
   
	std::vector<ValIndiceW> aux(coups.size());
	for (int i=coups.size()-1; i>=0; i--) {
		plateau.moveW(coups[i]);
		lastMove.ep=(coups[i].enPassant>=0);
		lastMove.prb=memPrb && coups[i].prb;
		lastMove.prn=memPrn && coups[i].prn;
		lastMove.grb=memGrb && coups[i].grb;
		lastMove.grn=memGrn && coups[i].grn;
		lastMove.dep=coups[i].dep;
		lastMove.arr=coups[i].arr;
		aux[i].indice=i;
		aux[i].eval=alphaBetaB(1,MIN,MAX);
		plateau.undoW(coups[i]);	
	}
	sort(aux.begin(),aux.end());
		
	for (int i=coups.size()-1; i>=0; i--) {	
	
		plateau.moveW(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0); 
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;

		eval=alphaBetaB(prof-3-floorpp(alpha-aux[i].eval),bInf,B);
		if (eval>alpha) {
			alpha=eval;
			if (alpha>A) bInf=alpha;
		} 
		if (alpha>=B) { 
			plateau.undoW(coups[aux[i].indice]);
			// stockage de l'evaluation
			if (tailleTablesW<TAILLE_MAX) { 
				bestProfW[cfs.keyB].push_back(prof-2,alpha,cfs.keyR);	
				tailleTablesW++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosW[prof-2]=-1;
			return alpha;
		}
		plateau.undoW(coups[aux[i].indice]);
	}
			
	// stockage de l'evaluation
	if (tailleTablesW<TAILLE_MAX) { 
		bestProfW[cfs.keyB].push_back(prof-2,alpha,cfs.keyR);	
		tailleTablesW++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosW[prof-2]=-1;
	return alpha;
} 
     
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote noir)
float AlphaBeta::alphaBetaProf_2B(float A,float B) {	

	if (secondMove) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}

	countAB++;

	// calcul de la signature du plateau
	Clefs cfs=plateau.cle();
	// ajout de la position
	repetPosB[prof-2]=cfs.keyB;

	findAllB();
	VectorMoves coups;
	coups.copie(setCoupsB);

	if (coups.empty()) {
		repetPosB[prof-2]=-1;
		if (check || sCheck>=0) return MAX;
		return 0;
	}

	float eval,beta=MAX,bSup=B;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;

	// pour des profondeurs entre prof et prof-2, on reordonne les coups suivant leur evaluation a pf==1
	avLMove.dep=lastMove.dep;
	avLMove.arr=lastMove.arr;
	avLMove.ep=memEp;
                 
	std::vector<ValIndiceB> aux(coups.size());
	for (int i=coups.size()-1; i>=0; i--) {
		plateau.moveB(coups[i]);
		lastMove.ep=(coups[i].enPassant>=0);
		lastMove.prb=memPrb && coups[i].prb;
		lastMove.prn=memPrn && coups[i].prn;
		lastMove.grb=memGrb && coups[i].grb;
		lastMove.grn=memGrn && coups[i].grn;
		lastMove.dep=coups[i].dep;
		lastMove.arr=coups[i].arr;
		aux[i].indice=i;
		aux[i].eval=alphaBetaW(1,MIN,MAX);
		plateau.undoB(coups[i]);
	}
	sort(aux.begin(),aux.end());

	for (int i=coups.size()-1; i>=0; i--) {	

		plateau.moveB(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0); 
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;

		eval=alphaBetaW(prof-3-floorpp(aux[i].eval-beta),A,bSup);
		if (eval<beta) {
			beta=eval;
			if (beta<B) bSup=beta;
		} 
		if (A>=beta) { 
			plateau.undoB(coups[aux[i].indice]);
			// stockage de l'evaluation 
			if (tailleTablesB<TAILLE_MAX) { 
				bestProfB[cfs.keyB].push_back(prof-2,beta,cfs.keyR);	
				tailleTablesB++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosB[prof-2]=-1;
			return beta;
		}
		plateau.undoB(coups[aux[i].indice]);
	}
	// stockage de l'evaluation 
	if (tailleTablesB<TAILLE_MAX) { 
		bestProfB[cfs.keyB].push_back(prof-2,beta,cfs.keyR);	
		tailleTablesB++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosB[prof-2]=-1;
	return beta;
}

/***********************************
* les alpha-beta autres profondeurs
***********************************/
    
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote blanc)
float AlphaBeta::alphaBetaW(int pf,float A,float B) {

	if (firstMove && pf==prof-3) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}
	else if (secondMove && pf==prof-2) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}

	countAB++;

	if (pf<=0) {
		if (prof>1) {
			// calcul de la signature du plateau, recherche dans les tables de transpo
			Clefs cfs=plateau.cle();
			for (int i=bestProfW[cfs.keyB].size()-1; i>=0; i--) {
				if (bestProfW[cfs.keyB][i].prof>=pf && bestProfW[cfs.keyB][i].clef==cfs.keyR) {
					countTables++;
					return bestProfW[cfs.keyB][i].eval; 
				}
			}
			if (pf>=0) {
				// ajout de la position, check si rencontre 3 fois (heuristique supposant bonne fonction de hashage)
				int comptRepet=0;
				for (int i=prof; i>0; i--) {
					if (repetPosW[i]<0) break;
					if (repetPosW[i]==(int)cfs.keyB) comptRepet++;
					if (comptRepet>=2) return 0;
				}
			}
		}

		// profondeurs negatives: on continue "intelligemment" que si prises possibles ou promotions
		return plateau.evalPosW()+findBestW();
	} 

	// calcul de la signature du plateau, recherche dans les tables de transpo
	Clefs cfs=plateau.cle();
	for (int i=bestProfW[cfs.keyB].size()-1; i>=0; i--) {
		if (bestProfW[cfs.keyB][i].prof>=pf && bestProfW[cfs.keyB][i].clef==cfs.keyR) {
			countTables++;
			return bestProfW[cfs.keyB][i].eval; 
		}
	}
	// ajout de la position, check si rencontre 3 fois (heuristique supposant bonne fonction de hashage)
	int comptRepet=0;
	for (int i=prof; i>pf; i--) {
		if (repetPosW[i]<0) break;
		if (repetPosW[i]==(int)cfs.keyB) comptRepet++;
		if (comptRepet>=2) return 0;
	}
	repetPosW[pf]=cfs.keyB;

	findAllW();
	VectorMoves coups;
	coups.copie(setCoupsW);

	if (coups.empty()) { 
		repetPosW[pf]=-1;
		if (check || sCheck>=0) return MIN;
		return 0;
	}
		
	float eval,alpha=MIN,bInf=A;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;
	
	if (pf>=2) {
		avLMove.dep=lastMove.dep;
		avLMove.arr=lastMove.arr;
		avLMove.ep=memEp;
	}

	// [meta]heuristique d'ordonnancement: on commence par les echanges, puis les coups de pions puis le reste
	HeurValInd* aux=new HeurValInd[coups.size()];
	for (int i=coups.size()-1; i>=0; i--) {
		aux[i].indice=i;          
		if (plateau[coups[i].arr]<=-2) aux[i].valeur=-plateau[coups[i].arr];
		else if (plateau[coups[i].dep]==1) aux[i].valeur=1;	
		else aux[i].valeur=0;
	}
	triLin(aux,coups.size());
	  
	for (int i=coups.size()-1; i>=0; i--) {	
		plateau.moveW(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0);
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;
		
		eval=alphaBetaB(pf-1,bInf,B);
		if (eval>alpha) {
			alpha=eval;
			if (alpha>A) bInf=alpha;
		}
		if (alpha>=B) { 
			plateau.undoW(coups[aux[i].indice]);
			// stockage de l'evaluation
			if (tailleTablesW<TAILLE_MAX) { 
				bestProfW[cfs.keyB].push_back(pf,alpha,cfs.keyR);	
				tailleTablesW++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosW[pf]=-1;
			delete [] aux;
			return alpha;
		}
		plateau.undoW(coups[aux[i].indice]);
	}
			
	// stockage de l'evaluation
	if (tailleTablesW<TAILLE_MAX) { 
		bestProfW[cfs.keyB].push_back(pf,alpha,cfs.keyR);	
		tailleTablesW++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosW[pf]=-1;
	delete [] aux;
	return alpha;
} 
     
// la fonction alpha-beta: renvoie l'evaluation a la profondeur demandee (cote noir)
float AlphaBeta::alphaBetaB(int pf,float A,float B) {	

	if (firstMove && pf==prof-3) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}
	else if (secondMove && pf==prof-2) {
		// cas d'arret time_over	
		if (tim.elapsed()>=tmp) { 
			stopped=true;
			return 0;
		}
	}

	countAB++;

	if (pf<=0) {
		if (prof>1) {
			// calcul de la signature du plateau, recherche dans les tables de transpo
			Clefs cfs=plateau.cle();
			for (int i=bestProfB[cfs.keyB].size()-1; i>=0; i--) {
				if (bestProfB[cfs.keyB][i].prof>=pf && bestProfB[cfs.keyB][i].clef==cfs.keyR) {
					countTables++;
					return bestProfB[cfs.keyB][i].eval; 
				}
			}
			if (pf>=0) {
				// ajout de la position, check si rencontre 3 fois (heuristique supposant bonne fonction de hashage)
				repetPosB[0]=cfs.keyB;
				int comptRepet=0;
				for (int i=prof; i>0; i--) {
					if (repetPosB[i]<0) break;
					if (repetPosB[i]==(int)cfs.keyB) comptRepet++;
					if (comptRepet>=2) return 0;
				}
			}
		}

		// profondeurs negatives: on continue "intelligemment" que si prises possibles ou promotions
		return plateau.evalPosB()-findBestB();
	} 

	// calcul de la signature du plateau, recherche dans les tables de transpo
	Clefs cfs=plateau.cle();
	for (int i=bestProfB[cfs.keyB].size()-1; i>=0; i--) {
		if (bestProfB[cfs.keyB][i].prof>=pf && bestProfB[cfs.keyB][i].clef==cfs.keyR) {
			countTables++;
			return bestProfB[cfs.keyB][i].eval; 
		}
	}
	// ajout de la position, check si rencontre 3 fois (heuristique supposant bonne fonction de hashage)
	int comptRepet=0;
	for (int i=prof; i>pf; i--) {
		if (repetPosB[i]<0) break;
		if (repetPosB[i]==(int)cfs.keyB) comptRepet++;
		if (comptRepet>=2) return 0;
	}
	repetPosB[pf]=cfs.keyB;

	findAllB();
	VectorMoves coups;
	coups.copie(setCoupsB);

	if (coups.empty()) {
		repetPosB[pf]=-1;
		if (check || sCheck>=0) return MAX;
		return 0;
	}

	float eval,beta=MAX,bSup=B;
	bool memPrb=lastMove.prb,memPrn=lastMove.prn,memGrb=lastMove.grb,memGrn=lastMove.grn,memEp=lastMove.ep;

	if (pf>=2) {
		avLMove.dep=lastMove.dep;
		avLMove.arr=lastMove.arr;
		avLMove.ep=memEp;
	}

	// [meta]heuristique d'ordonnancement: on commence par les echanges, puis les coups de pions puis le reste
	HeurValInd* aux=new HeurValInd[coups.size()];
	for (int i=coups.size()-1; i>=0; i--) {
		aux[i].indice=i;          
		if (plateau[coups[i].arr]>=2) aux[i].valeur=plateau[coups[i].arr];
		else if (plateau[coups[i].dep]==-1) aux[i].valeur=1;	
		else aux[i].valeur=0;
	}
	triLin(aux,coups.size());

	for (int i=coups.size()-1; i>=0; i--) {	

		plateau.moveB(coups[aux[i].indice]);
		lastMove.ep=(coups[aux[i].indice].enPassant>=0);
		lastMove.prb=memPrb && coups[aux[i].indice].prb;
		lastMove.prn=memPrn && coups[aux[i].indice].prn;
		lastMove.grb=memGrb && coups[aux[i].indice].grb;
		lastMove.grn=memGrn && coups[aux[i].indice].grn;
		lastMove.dep=coups[aux[i].indice].dep;
		lastMove.arr=coups[aux[i].indice].arr;

		eval=alphaBetaW(pf-1,A,bSup);
		if (eval<beta) {
			beta=eval;
			if (beta<B) bSup=beta;
		} 
		if (A>=beta) { 
			plateau.undoB(coups[aux[i].indice]);
			// stockage de l'evaluation 
			if (tailleTablesB<TAILLE_MAX) { 
				bestProfB[cfs.keyB].push_back(pf,beta,cfs.keyR);	
				tailleTablesB++;
			}
			lastMove.ep=memEp;
			lastMove.prb=memPrb;
			lastMove.prn=memPrn;
			lastMove.grb=memGrb;
			lastMove.grn=memGrn;
			repetPosB[pf]=-1;
			delete [] aux;
			return beta;
		}
		plateau.undoB(coups[aux[i].indice]);
	}
	if (tailleTablesB<TAILLE_MAX) { 
		bestProfB[cfs.keyB].push_back(pf,beta,cfs.keyR);	
		tailleTablesB++;
	}
	lastMove.ep=memEp;
	lastMove.prb=memPrb;
	lastMove.prn=memPrn;
	lastMove.grb=memGrb;
	lastMove.grn=memGrn;
	repetPosB[pf]=-1;
	delete [] aux;
	return beta;
}

/*************************************************************
* fonction pour reordonner les coups "dans l'ordre de depart"
**************************************************************/

void AlphaBeta::random_permutW(std::vector<EvalCoupW>& evcp,int nbElts) const {
	srand(getpid());
	std::vector<EvalCoupW> aux;
	bool* dejaChoisi=(bool*)calloc(nbElts,sizeof(bool));
	for (int i=evcp.size()-1; i>(int)evcp.size()-1-nbElts; i--) {
		int indice=rand()%nbElts;
		while (dejaChoisi[indice]) indice=rand()%nbElts;
		dejaChoisi[indice]=true;
		aux.push_back(evcp[evcp.size()-1-indice]);
	}
	for (int i=nbElts-1; i>=0; i--) evcp[evcp.size()-1-i]=aux[i];
	
	return;
}
void AlphaBeta::random_permutB(std::vector<EvalCoupB>& evcp,int nbElts) const {
	srand(getpid());
	std::vector<EvalCoupB> aux;
	bool* dejaChoisi=(bool*)calloc(nbElts,sizeof(bool));
	for (int i=evcp.size()-1; i>(int)evcp.size()-1-nbElts; i--) {
		int indice=rand()%nbElts;
		while (dejaChoisi[indice]) indice=rand()%nbElts;
		dejaChoisi[indice]=true;
		aux.push_back(evcp[evcp.size()-1-indice]);
	}
	for (int i=nbElts-1; i>=0; i--) evcp[evcp.size()-1-i]=aux[i];
	
	return;
}

void AlphaBeta::tri_ordonneW(std::vector<EvalCoupW>& ord) const {

	std::vector<EvalCoupW> aux; 
	// on recherche pas a pas le plus grand element que l'on copie suivant son apparition
	float min,lastEval=MIN-1;
	std::vector<int> indices;
	while (aux.size()<ord.size()) {
		
		// a) determination du min
		min=MAX+1;
		for (int i=(int)ord.size()-1; i>=0; i--) {
			if (ord[i].eval>lastEval) {
				if (ord[i].eval<min) {
					min=ord[i].eval;
					indices.clear();
					indices.push_back(i);
				}
				else if (ord[i].eval==min) indices.push_back(i);
			}
		}
		lastEval=min;
		
		// b) ajout des elements correspondant
		for (int i=(int)indices.size()-1; i>=0; i--) aux.push_back(ord[indices[i]]);
	}
	
	// si meilleure eval tres bonne, permutation aleatoire des meilleurs coups
	if (aux.back().eval>2) {
		float best=aux.back().eval;
		int ind=aux.size()-1;
		while (ind>=0 && aux[ind].eval>=best) ind--;
		random_permutW(aux,aux.size()-1-ind);
	}
	
	ord=aux;
	return;
}
void AlphaBeta::tri_ordonneB(std::vector<EvalCoupB>& ord) const {

	std::vector<EvalCoupB> aux; 
	// on recherche pas a pas le plus petit element que l'on copie suivant son apparition
	float max,lastEval=MAX+1;
	std::vector<int> indices;
	while (aux.size()<ord.size()) {
		
		// a) determination du max
		max=MIN-1;
		for (int i=(int)ord.size()-1; i>=0; i--) {
			if (ord[i].eval<lastEval) {
				if (ord[i].eval>max) {
					max=ord[i].eval;
					indices.clear();
					indices.push_back(i);
				}
				else if (ord[i].eval==max) indices.push_back(i);
			}
		}
		lastEval=max;
		
		// b) ajout des elements correspondant
		for (int i=(int)indices.size()-1; i>=0; i--) aux.push_back(ord[indices[i]]);
	}
	
	// si meilleure eval tres bonne, permutation aleatoire des meilleurs coups
	if (aux.back().eval<-2) {
		float best=aux.back().eval;
		int ind=aux.size()-1;
		while (ind>=0 && aux[ind].eval<=best) ind--;
		random_permutB(aux,aux.size()-1-ind);
	}
	
	ord=aux;
	return;
}

/***************************************
* tri casiers: lineaire pour les entiers
***************************************/

void AlphaBeta::triLin(HeurValInd* valInd,int sz) {
	// a implementer
	return;
}
