#ifndef _Coup
#define _Coup

#include <iostream>

/* structure utilise pour coder un coup "light", juste avec flags et cases */
struct LightMove {
	LightMove () {
		dep=0;
		arr=0;
		prb=true;
		prn=true;
		grb=true;
		grn=true;
		ep=false;
	}
	LightMove (int d,int a,bool pb,bool pn,bool gb,bool gn) {
		dep=d;
		arr=a;
		prb=pb;
		prn=pn;
		grb=gb;
		grn=gn;
		ep=false;
	}
	int dep,arr; /* cases de deplacement */
	bool prb,prn,grb,grn,ep; /* petit roque blanc..etc */
};

/* encore plus leger: l'avant-dernier coup, juste dep, arr et ep */
struct AvLastMove {
	AvLastMove () {
		dep=-1;
		arr=-1;
		ep=false;
	}
	int dep,arr;
	bool ep;
};

class Coup {

public:

	/* constructeur "vide" */
	Coup() {
		enPassant=-1;
		roque=false;
		promotion=0;
		prb=true;
		prn=true;
		grb=true;
		grn=true; 
	}

	/* constructeur prenant en paramtre deux cases (on ajoutera les pions pris ailleurs..) */
	Coup(int case1, int case2) {  
		enPassant=-1; 
		roque=false;
		promotion=0;
		capture=0;
		prb=true;
		prn=true;
		grb=true;
		grn=true;              
		dep=case1;
		arr=case2;
	}

	/* constructeur par recopie */
	Coup(const Coup& cp) {
		enPassant=cp.enPassant; 
		promotion=cp.promotion;
		roque=cp.roque;
		capture=cp.capture;
		prb=cp.prb;
		prn=cp.prn;
		grb=cp.grb;
		grn=cp.grn;
		dep=cp.dep;
		arr=cp.arr; 
	} 

	/* redefinition d'une fonction d'egalite */
	bool operator==(const Coup& cp) const {
		return (dep==cp.dep && arr==cp.arr);
	}

	/* destructeur (rien  faire car pas de cration explicite de pointeur) */
	~Coup() {}

	/* indique si roque */
	bool roque; 

	/* dans le cas d'une promotion, piece de promo (0=pas de promotion,2=caval..etc), et case de prise en passant */
	int promotion,enPassant;

	/* capture eventuelle du coup courant */
	int capture;

	/* memorise si un petit roque/grand roque est autorise pour les blancs ou les noirs a partir de ce coup */
	bool prb,prn,grb,grn; /* petit roque blanc..etc */

	/* attributs dcrivant le coup */         
	int dep,arr; 

};

/* ecriture d'un coup dans un flux */
extern std::ostream& operator<<(std::ostream& o, const Coup &cp);

#endif
