#include "Global.h"
#include "Definitions.h"
#include "Echanges.h"

// peut-on prendre sur sq ?
bool canTakeW(int sq) {
	coupAux.arr=sq;
	// coups de pions 
	if (sq>=16) {
		if (mod8[sq]>0 && plateau[sq-9]==1) {
			coupAux.dep=sq-9;
			if (!underCheckW(coupAux)) return true;
		}
		if (mod8[sq]<7 && plateau[sq-7]==1) {
			coupAux.dep=sq-7;
			if (!underCheckW(coupAux)) return true;
		}
	}

	// coups de cavalier: exploration a droite
	if (mod8[sq]<6) {
		if (sq+10<64 && plateau[sq+10]==2) {
			coupAux.dep=sq+10;
			if (!underCheckW(coupAux)) return true;	
		}	
		if (sq-6>=0 && plateau[sq-6]==2) {	
			coupAux.dep=sq-6;
			if (!underCheckW(coupAux)) return true;
		}
	}
	// exploration a gauche
	if (mod8[sq]>1) {
		if (sq+6<64 && plateau[sq+6]==2) {
			coupAux.dep=sq+6;
			if (!underCheckW(coupAux)) return true;
		}
		if (sq-10>=0 && plateau[sq-10]==2) {
			coupAux.dep=sq-10;
			if (!underCheckW(coupAux)) return true;
		}
	} 
	// exploration en haut
	if (sq<48) {
		if (mod8[sq]!=7 && plateau[sq+17]==2) {
			coupAux.dep=sq+17;
			if (!underCheckW(coupAux)) return true;
		}
		if (mod8[sq]!=0 && plateau[sq+15]==2) {
			coupAux.dep=sq+15;
			if (!underCheckW(coupAux)) return true;
		}
	}
	// exploration en bas
	if (sq>=16) {
		if (mod8[sq]!=7 && plateau[sq-15]==2) {
			coupAux.dep=sq-15;
			if (!underCheckW(coupAux)) return true;
		}
		if (mod8[sq]!=0 && plateau[sq-17]==2) {
			coupAux.dep=sq-17;
			if (!underCheckW(coupAux)) return true;
		}
	} 
	
	// fou et dames en diagonale
	for (int i=sq+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
	
	// tours et dames vertical/horizontal
	if (sq<64) {
		// parcours horizontale droite
		for (int i=sq+1; mod8[i]>0; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					coupAux.dep=i;
					if (!underCheckW(coupAux)) return true;
				}
				break;
			}
		}
	}
	if (sq>=0) {
		// parcours horizontale gauche
		for (int i=sq-1; mod8[i]<7; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					coupAux.dep=i;
					if (!underCheckW(coupAux)) return true;
				}
				break;
			}
		}
	}
	// parcours verticale haute
	for (int i=sq+8; i<64; i+=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
	// parcours verticale basse
	for (int i=sq-8; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				coupAux.dep=i;
				if (!underCheckW(coupAux)) return true;
			}
			break;
		}
	}
			
	// check roi
	if (abs(mod8[plateau.roiB]-mod8[sq])<=1 && abs(div8[plateau.roiB]-div8[sq])<=1) {
		coupAux.dep=plateau.roiB;
		if (!underCheckW_K(coupAux)) return true;
	}

	return false;
}

// peut-on prendre sur sq ?
bool canTakeB(int sq) {
	coupAux.arr=sq;
	// coups de pions 
	if (sq<48) {
		if (mod8[sq]>0 && plateau[sq+7]==-1) {
			coupAux.dep=sq+7;
			if (!underCheckB(coupAux)) return true;
		}
		if (mod8[sq]<7 && plateau[sq+9]==-1) {
			coupAux.dep=sq+9;
			if (!underCheckB(coupAux)) return true;
		}
	}
		
	// coups de cavalier: exploration a droite
	if (mod8[sq]<6) {
		if (sq+10<64 && plateau[sq+10]==-2) {
			coupAux.dep=sq+10;
			if (!underCheckB(coupAux)) return true;	
		}	
		if (sq-6>=0 && plateau[sq-6]==-2) {	
			coupAux.dep=sq-6;
			if (!underCheckB(coupAux)) return true;
		}
	}
	// exploration a gauche
	if (mod8[sq]>1) {
		if (sq+6<64 && plateau[sq+6]==-2) {
			coupAux.dep=sq+6;
			if (!underCheckB(coupAux)) return true;
		}
		if (sq-10>=0 && plateau[sq-10]==-2) {
			coupAux.dep=sq-10;
			if (!underCheckB(coupAux)) return true;
		}
	}
	// exploration en haut
	if (sq<48) {
		if (mod8[sq]!=7 && plateau[sq+17]==-2) {
			coupAux.dep=sq+17;
			if (!underCheckB(coupAux)) return true;
		}
		if (mod8[sq]!=0 && plateau[sq+15]==-2) {
			coupAux.dep=sq+15;
			if (!underCheckB(coupAux)) return true;
		}
	}
	// exploration en bas
	if (sq>=16) {
		if (mod8[sq]!=7 && plateau[sq-15]==-2) {
			coupAux.dep=sq-15;
			if (!underCheckB(coupAux)) return true;
		}
		if (mod8[sq]!=0 && plateau[sq-17]==-2) {
			coupAux.dep=sq-17;
			if (!underCheckB(coupAux)) return true;
		}
	} 
	
	// fou et dames en diagonale
	for (int i=sq+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
	for (int i=sq-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
	
	// tours et dames vertical/horizontal
	if (sq<64) {
		// parcours horizontale droite
		for (int i=sq+1; mod8[i]>0; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					coupAux.dep=i;
					if (!underCheckB(coupAux)) return true;
				}
				break;
			}
		}
	}
	if (sq>=0) {
		// parcours horizontale gauche
		for (int i=sq-1; mod8[i]<7; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					coupAux.dep=i;
					if (!underCheckB(coupAux)) return true;
				}
				break;
			}
		}
	}
	// parcours verticale haute
	for (int i=sq+8; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
	// parcours verticale basse
	for (int i=sq-8; i>=0; i-=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				coupAux.dep=i;
				if (!underCheckB(coupAux)) return true;
			}
			break;
		}
	}
			
	// check roi
	if (abs(mod8[plateau.roiN]-mod8[sq])<=1 && abs(div8[plateau.roiN]-div8[sq])<=1) {
		coupAux.dep=plateau.roiN;
		if (!underCheckB_K(coupAux)) return true;
	}

	return false;
}

int findBestW() {

	for (int i=63; i>=0; i--) dejaVuVal[i]=16;
	int bestExchange=0;
	coup.enPassant=-1;
	for (int i=63; i>=0; i--) {
	
		if (plateau[i]<=0) continue;
		
		coup.dep=i;

		if (plateau[i]==1) {
		
			// promotions sans prise: shortcut
			if (i>=48 && plateau[i+8]==0) {
				coup.arr=i+8;
				if (!underCheckW(coup)) {
					plateau.ghostMoveNEP_W(coup);
					if (!canTakeB(coup.arr)) {
						plateau.ghostUndoNEP_W(coup);
						return 8;
					}
					plateau.ghostUndoNEP_W(coup);
				}
			}
			
			// prise en passant
			if (plateau[lastMove.arr]==-1 && lastMove.dep-lastMove.arr==16) {
				if (i==lastMove.arr-1) {
					coup.enPassant=lastMove.arr;
					coup.arr=i+9;
					if (!underCheckW(coup)) {
						plateau.ghostMoveW(coup);
						if (!canTakeB(coup.arr)) {
							if (1>bestExchange) bestExchange=1;
						}
						plateau.ghostUndoW(coup);
					}
					coup.enPassant=-1;
				}
				else if (i==lastMove.arr+1) {
					coup.enPassant=lastMove.arr;
					coup.arr=i+7;
					if (!underCheckW(coup)) {
						plateau.ghostMoveW(coup);
						if (!canTakeB(coup.arr)) {
							if (1>bestExchange) bestExchange=1;
						}
						plateau.ghostUndoW(coup);
					}
					coup.enPassant=-1;
				}
			}
			
			// prises, eventuellement avec promotions
			if (mod8[i]>0 && plateau[i+7]<0) {
				coup.arr=i+7;
				if (!underCheckW(coup)) {
					dejaVuVal[coup.arr]=1;
					plateau.ghostMoveNEP_W(coup);
					if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-1);
					else {
						if (i<48) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						else {
							plateau.ghostUndoNEP_W(coup);
							return toVal[coup.capture+5]+8;
						}
					}
					plateau.ghostUndoNEP_W(coup);
				}
			}
			if (mod8[i]<7 && plateau[i+9]<0) {
				coup.arr=i+9;
				if (!underCheckW(coup)) {
					dejaVuVal[coup.arr]=1;
					plateau.ghostMoveNEP_W(coup);
					if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-1);
					else {
						if (i<48) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						else {
							plateau.ghostUndoNEP_W(coup);
							return toVal[coup.capture+5]+8;
						}
					}
					plateau.ghostUndoNEP_W(coup); 
				}
			}
		}

		else if (plateau[i]==2) {
			// exploration a droite
			if (mod8[i]<6) {
				if (i+10<64 && plateau[i+10]<0) {
					coup.arr=i+10;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}	
				if (i-6>=0 && plateau[i-6]<0) {	
					coup.arr=i-6;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
			}
		
			// exploration a gauche
			if (mod8[i]>1) {
				if (i+6<64 && plateau[i+6]<0) {
					coup.arr=i+6;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
				if (i-10>=0 && plateau[i-10]<0) {
					coup.arr=i-10;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
			}
			
			// exploration en haut
			if (i<48) {
				if (mod8[i]!=7 && plateau[i+17]<0) {
					coup.arr=i+17;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
				if (mod8[i]!=0 && plateau[i+15]<0) {
					coup.arr=i+15;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
			}
			
			// exploration en bas
			if (i>=16) {
				if (mod8[i]!=7 && plateau[i-15]<0) {
					coup.arr=i-15;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
				if (mod8[i]!=0 && plateau[i-17]<0) {
					coup.arr=i-17;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
				}
			}
		}

		else if (plateau[i]==3) {
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration diagonale h-droite
			while (mod8[posCour]!=7 && posCour<55) {
				posCour+=9;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale h-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour<56) {
				posCour+=7;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale b-droite
			posCour=i;
			while (mod8[posCour]!=7 && posCour>=8) {
				posCour-=7;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale b-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour>=9) {
				posCour-=9;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
		}
		
		else if (plateau[i]==4) {
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration verticale haute
			while (posCour<56) { 
				posCour+=8;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration verticale basse
			posCour=i;
			while (posCour>=8) { 
				posCour-=8;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration horizontale droite
			posCour=i;
			while (mod8[posCour]!=7) { 
				posCour++;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration horizontale gauche
			posCour=i;
			while (mod8[posCour]!=0) { 
				posCour--;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_W(coup);
						if (canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
		} 

		else if (plateau[i]==5) {
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration diagonale h-droite
			while (mod8[posCour]!=7 && posCour<55) {
				posCour+=9;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale h-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour<56) {
				posCour+=7;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale b-droite
			posCour=i;
			while (mod8[posCour]!=7 && posCour>=8) {
				posCour-=7;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration diagonale b-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour>=9) {
				posCour-=9;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration verticale haute
			posCour=i;		
			while (posCour<56) { 
				posCour+=8;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration verticale basse
			posCour=i;
			while (posCour>=8) { 
				posCour-=8;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration horizontale droite
			posCour=i;
			while (mod8[posCour]!=7) { 
				posCour++;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
			// exploration horizontale gauche
			posCour=i;
			while (mod8[posCour]!=0) { 
				posCour--;
				if (plateau[posCour]>0) break;
				if (plateau[posCour]<0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckW(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_W(coup);
						if (!canTakeB(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_W(coup);
					}
					break;
				}
			}
		}

		else { // roi blanc
			// bord gauche
			if (mod8[i]==0) { 
				if (i>=8) {
					if (plateau[i-7]<0) {
						coup.arr=i-7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
					if (plateau[i-8]<0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
				}
				if (plateau[i+1]<0) {
					coup.arr=i+1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (i<55) {
					if (plateau[i+9]<0) {
						coup.arr=i+9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]<0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
				}   
			}
			else if (mod8[i]==7) { // bord droit
				if (i>=9) {
					if (plateau[i-9]<0) {
						coup.arr=i-9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-8]<0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
				}
				if (plateau[i-1]<0) {
					coup.arr=i-1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (i<56) {
					if (plateau[i+7]<0) {
						coup.arr=i+7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]<0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
				} 
			}
			else { // milieu du plateau
				// deplacements lateraux toujours possibles
				if (plateau[i-1]<0) { 
					coup.arr=i-1; 
					if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (plateau[i+1]<0) {
					coup.arr=i+1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				} 
				if (i>=8) {
					if (plateau[i-7]<0) {
						coup.arr=i-7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-8]<0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-9]<0) {
						coup.arr=i-9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}   
				} 
				if (i<55) {
					if (plateau[i+9]<0) {
						coup.arr=i+9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]<0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
					if (plateau[i+7]<0) {
						coup.arr=i+7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckW_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					} 
				}
			}
		}
	}
	
	return bestExchange;
}
		
int findBestB() {

	for (int i=63; i>=0; i--) dejaVuVal[i]=16;
	int bestExchange=0;
	coup.enPassant=-1;
	for (int i=63; i>=0; i--) {
	
		if (plateau[i]>=0) continue;
		
		coup.dep=i;
		
		if (plateau[i]==-1) {
		
			// promotions sans prise: shortcut
			if (i<16 && plateau[i-8]==0) {
				coup.arr=i-8;
				if (!underCheckB(coup)) {
					plateau.ghostMoveNEP_W(coup);
					if (!canTakeW(coup.arr)) {
						plateau.ghostUndoNEP_W(coup);
						return 8;
					}
					plateau.ghostUndoNEP_W(coup);
				}
			}
			
			// prise en passant
			if (plateau[lastMove.arr]==1 && lastMove.arr-lastMove.dep==16) {
				if (i==lastMove.arr-1) {
					coup.enPassant=lastMove.arr;
					coup.arr=i-7;
					if (!underCheckB(coup)) {
						plateau.ghostMoveB(coup);
						if (!canTakeW(coup.arr)) {
							if (1>bestExchange) bestExchange=1;
						}
						plateau.ghostUndoB(coup);
					}
					coup.enPassant=-1;
				}
				else if (i==lastMove.arr+1) {
					coup.enPassant=lastMove.arr;
					coup.arr=i-9;
					if (!underCheckB(coup)) {
						plateau.ghostMoveB(coup);
						if (!canTakeW(coup.arr)) {
							if (1>bestExchange) bestExchange=1;
						}
						plateau.ghostUndoB(coup);
					}
					coup.enPassant=-1;
				}
			}
		
			// prises, eventuellement avec promotions
			if (mod8[i]>0 && plateau[i-9]>0) {
				coup.arr=i-9;
				if (!underCheckB(coup)) {
					dejaVuVal[coup.arr]=1;
					plateau.ghostMoveNEP_B(coup);
					if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-1);
					else {
						if (i>=16) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						else {
							plateau.ghostUndoNEP_B(coup);
							return toVal[coup.capture+5]+8;
						}
					}
					plateau.ghostUndoNEP_B(coup);
				}
			}
			if (mod8[i]<7 && plateau[i-7]>0) {
				coup.arr=i-7;
				if (!underCheckB(coup)) {
					dejaVuVal[coup.arr]=1;
					plateau.ghostMoveNEP_B(coup);
					if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-1);
					else {
						if (i>=16) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						else {
							plateau.ghostUndoNEP_B(coup);
							return toVal[coup.capture+5]+8;
						}
					}
					plateau.ghostUndoNEP_B(coup);
				}
			}
		}
		
		else if (plateau[i]==-2) {
			// exploration a droite
			if (mod8[i]<6) {
				if (i+10<64 && plateau[i+10]>0) {
					coup.arr=i+10;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}	
				if (i-6>=0 && plateau[i-6]>0) {	
					coup.arr=i-6;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
			}
		
			// exploration a gauche
			if (mod8[i]>1) {
				if (i+6<64 && plateau[i+6]>0) {
					coup.arr=i+6;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
				if (i-10>=0 && plateau[i-10]>0) {
					coup.arr=i-10;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
			}
			
			// exploration en haut
			if (i<48) {
				if (mod8[i]!=7 && plateau[i+17]>0) {
					coup.arr=i+17;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
				if (mod8[i]!=0 && plateau[i+15]>0) {
					coup.arr=i+15;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
			}
			
			// exploration en bas
			if (i>=16) {
				if (mod8[i]!=7 && plateau[i-15]>0) {
					coup.arr=i-15;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
				if (mod8[i]!=0 && plateau[i-17]>0) {
					coup.arr=i-17;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
				}
			}
		}
		
		else if (plateau[i]==-3) {
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration diagonale h-droite
			while (mod8[posCour]!=7 && posCour<55) {
				posCour+=9;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale h-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour<56) {
				posCour+=7;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale b-droite
			posCour=i;
			while (mod8[posCour]!=7 && posCour>=8) {
				posCour-=7;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale b-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour>=9) {
				posCour-=9;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>3 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=3;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-3);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
		}
		
		else if (plateau[i]==-4) { 
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration verticale haute
			while (posCour<56) { 
				posCour+=8;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration verticale basse
			posCour=i;
			while (posCour>=8) { 
				posCour-=8;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration horizontale droite
			posCour=i;
			while (mod8[posCour]!=7) { 
				posCour++;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration horizontale gauche
			posCour=i;
			while (mod8[posCour]!=0) { 
				posCour--;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>5 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=5;
						plateau.ghostMoveNEP_B(coup);
						if (canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]-5);
						else bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
		} 
		
		else if (plateau[i]==-5) {
			int posCour=i; // position courante de recherche: on s'arrete lorsque a) mur b) ami c) ennemi
			// exploration diagonale h-droite
			while (mod8[posCour]!=7 && posCour<55) {
				posCour+=9;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale h-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour<56) {
				posCour+=7;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale b-droite
			posCour=i;
			while (mod8[posCour]!=7 && posCour>=8) {
				posCour-=7;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration diagonale b-gauche
			posCour=i;
			while (mod8[posCour]!=0 && posCour>=9) {
				posCour-=9;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration verticale haute
			posCour=i;		
			while (posCour<56) { 
				posCour+=8;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration verticale basse
			posCour=i;
			while (posCour>=8) { 
				posCour-=8;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration horizontale droite
			posCour=i;
			while (mod8[posCour]!=7) { 
				posCour++;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
			// exploration horizontale gauche
			posCour=i;
			while (mod8[posCour]!=0) { 
				posCour--;
				if (plateau[posCour]<0) break;
				if (plateau[posCour]>0) {
					coup.arr=posCour;
					if (dejaVuVal[coup.arr]>9 && !underCheckB(coup)) {
						dejaVuVal[coup.arr]=9;
						plateau.ghostMoveNEP_B(coup);
						if (!canTakeW(coup.arr)) bestExchange=max(bestExchange,toVal[coup.capture+5]);
						plateau.ghostUndoNEP_B(coup);
					}
					break;
				}
			}
		}

		else { // roi noir
			// bord gauche
			if (mod8[i]==0) { 
				if (i>=8) {
					if (plateau[i-7]>0) {
						coup.arr=i-7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
					if (plateau[i-8]>0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
				}
				if (plateau[i+1]>0) {
					coup.arr=i+1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (i<55) {
					if (plateau[i+9]>0) {
						coup.arr=i+9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]>0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
				}   
			}
			else if (mod8[i]==7) { // bord droit
				if (i>=9) {
					if (plateau[i-9]>0) {
						coup.arr=i-9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-8]>0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
				}
				if (plateau[i-1]>0) {
					coup.arr=i-1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (i<56) {
					if (plateau[i+7]>0) {
						coup.arr=i+7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]>0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
				} 
			}
			else { // milieu du plateau
				// deplacements lateraux toujours possibles
				if (plateau[i-1]>0) { 
					coup.arr=i-1; 
					if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				}  
				if (plateau[i+1]>0) {
					coup.arr=i+1;
					if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
						bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
				} 
				if (i>=8) {
					if (plateau[i-7]>0) {
						coup.arr=i-7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-8]>0) {
						coup.arr=i-8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i-9]>0) {
						coup.arr=i-9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}   
				} 
				if (i<55) {
					if (plateau[i+9]>0) {
						coup.arr=i+9;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}  
					if (plateau[i+8]>0) {
						coup.arr=i+8;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					}
					if (plateau[i+7]>0) {
						coup.arr=i+7;
						if (dejaVuVal[coup.arr]>=16 && !underCheckB_K(coup))
							bestExchange=max(bestExchange,toVal[plateau[coup.arr]+5]);
					} 
				}
			}
		}
	}
	
	return bestExchange;
}
