#ifndef _Global
#define _Global

/* variables globales utiles en de nombreux endroits */

#include "Coup.h"
#include "Plateau.h"
#include "VectorMoves.h"

class Global {

public:

	Global();

	/* ensemble des coups possibles pour chaque couleur (mis a jour incrementalement)*/
	static VectorMoves setCoupsW,coupsRoiW,setCoupsB,coupsRoiB,coupsAux;
	
	/* booleens indiquant si un camp etait en echec au coup precedent */
	static bool lastCheckW,lastCheckB;

	/* dernier et avant-dernier coups joues */
	static LightMove lastMove;
	static AvLastMove avLMove;
	
	/* coup temporaire pour la recherche de coups */
	static Coup coup,coupAux;

	/* case d'attaque du roi, eventuellement */
	static int attackSq;
	
	/* plateau de jeu */
	static Plateau plateau;
	
	/* booleens pour les verifications d'echec */
	static bool check,dec;
	static int sCheck; /* case d'echec si decouverte seule */

	/* tableaux de modulos/DE */
	static int mod8[64];
	static int div8[64];

	/* cases deja visitees pour findBest */
	static int dejaVuVal[64];
	
	/* tableau des valeurs des pieces */
	static int toVal[11];
	
	/* index des coups a supprimer pour mise a jour incrementale */
	static int indexMoves[128];
	
	~Global() {}

};

#endif
