#include "Global.h"
#include "Definitions.h"
#include "UnderCheck.h"

// effectue une verification d'echec sur un coup potentiel, roi pas en echec avant le coup, cp != coup de roi
bool underCheckW(Coup& cp) {
	plateau.ghostMoveW(cp); 
	int i;

	// => il suffit de verifier si la piece jouee ne decouvre pas une attaque de fou, tour ou dame

	if (mod8[cp.dep]!=mod8[cp.arr]) {
		if (div8[cp.dep]!=div8[cp.arr]) { 
			// check si le roi etait sur la meme colonne
			if (mod8[plateau.roiB]==mod8[cp.dep]) {
				// roi derriere la piece
				if (plateau.roiB<cp.dep) {
					// check colonne
					for (i=plateau.roiB+8; i<64; i+=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
				// roi devant la piece
				else {
					// check colonne
					for (i=plateau.roiB-8; i>=0; i-=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
			}
			// puis sur la mme rangee
			else if (div8[plateau.roiB]==div8[cp.dep]) {
				// roi a gauche de la piece
				if (plateau.roiB<cp.dep) {
					// check rangee
					for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
				// roi a droite de la piece
				else {
					// check rangee
					for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
			}
			// enfin, sur la meme diagonale
			else if (div8[plateau.roiB]-div8[cp.dep]==mod8[plateau.roiB]-mod8[cp.dep]) {
				if (div8[cp.dep]-div8[cp.arr]!=mod8[cp.dep]-mod8[cp.arr]) {
					// roi a gauche de la piece
					if (plateau.roiB<cp.dep) {
						// check diago
						for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								plateau.ghostUndoW(cp);
								if (plateau[i]==-3 || plateau[i]==-5) return true;		
								return false;
							}
						}
						if (i<64 && plateau[i]<0 && mod8[i]!=0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					// roi a droite la piece
					else {
						// check diago
						for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								plateau.ghostUndoW(cp);
								if (plateau[i]==-3 || plateau[i]==-5) return true;		
								return false;
							}
						}
						if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
			}
			else if (div8[plateau.roiB]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiB]) {
				if (div8[cp.dep]-div8[cp.arr]!=mod8[cp.arr]-mod8[cp.dep]) {
					// roi a droite de la piece
					if (plateau.roiB<cp.dep) { 
						// check diago
						for (i=plateau.roiB+7; i<64 && mod8[i]>0; i+=7) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								plateau.ghostUndoW(cp);
								if (plateau[i]==-3 || plateau[i]==-5) return true;		
								return false;
							}
						}
						if (i<64 && plateau[i]<0 && mod8[i]!=7) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					// roi a gauche la piece
					else {
						// check diago
						for (i=plateau.roiB-7; i>=0 && mod8[i]<7; i-=7) {
							if (plateau[i]>0) break;
							if (plateau[i]<0) {
								plateau.ghostUndoW(cp);
								if (plateau[i]==-3 || plateau[i]==-5) return true;		
								return false;
							}
						}
						if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
			}
		}
		else {
			// check si le roi etait sur la meme colonne
			if (mod8[plateau.roiB]==mod8[cp.dep]) {
				// roi derriere la piece
				if (plateau.roiB<cp.dep) {
					// check colonne
					for (i=plateau.roiB+8; i<64; i+=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
				// roi devant la piece
				else {
					// check colonne
					for (i=plateau.roiB-8; i>=0; i-=8) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-4 || plateau[i]==-5) return true;		
							return false;
						}
					}
				}
			}
			// puis sur la meme diagonale
			else if (div8[plateau.roiB]-div8[cp.dep]==mod8[plateau.roiB]-mod8[cp.dep]) {
				// roi a gauche de la piece
				if (plateau.roiB<cp.dep) {
					// check diago
					for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					if (i<64 && plateau[i]<0 && mod8[i]!=0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				// roi a droite la piece
				else {
					// check diago
					for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
			}
			else if (div8[plateau.roiB]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiB]) {
				// roi a droite de la piece
				if (plateau.roiB<cp.dep) {
					// check diago
					for (i=plateau.roiB+7; i<64 && mod8[i]>0; i+=7) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					if (i<64 && plateau[i]<0 && mod8[i]!=7) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				// roi a gauche la piece
				else {
					// check diago
					for (i=plateau.roiB-7; i>=0 && mod8[i]<7; i-=7) {
						if (plateau[i]>0) break;
						if (plateau[i]<0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==-3 || plateau[i]==-5) return true;		
							return false;
						}
					}
					if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
			}
		}
	}
	else {
		// check si le roi etait sur la mme rangee
		if (div8[plateau.roiB]==div8[cp.dep]) {
			// roi a gauche de la piece
			if (plateau.roiB<cp.dep) {
				// check rangee
				for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-4 || plateau[i]==-5) return true;		
						return false;
					}
				}
			}
			// roi a droite la piece
			else {
				// check rangee
				for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-4 || plateau[i]==-5) return true;		
						return false;
					}
				}
			}
		}
		// puis sur la meme diagonale
		else if (div8[plateau.roiB]-div8[cp.dep]==mod8[plateau.roiB]-mod8[cp.dep]) {
			// roi a gauche de la piece
			if (plateau.roiB<cp.dep) {
				// check diago
				for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=0) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==-3 || plateau[i]==-5) return true;		
					return false;
				}
			}
			// roi a droite la piece
			else {
				// check diago
				for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=7) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==-3 || plateau[i]==-5) return true;		
					return false;
				}
			}
		}
		else if (div8[plateau.roiB]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiB]) {
			// roi a droite de la piece
			if (plateau.roiB<cp.dep) {
				// check diago
				for (i=plateau.roiB+7; i<64 && mod8[i]>0; i+=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				if (i<64 && plateau[i]<0 && mod8[i]!=7) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==-3 || plateau[i]==-5) return true;		
					return false;
				}
			}
			// roi a gauche la piece
			else {
				// check diago
				for (i=plateau.roiB-7; i>=0 && mod8[i]<7; i-=7) {
					if (plateau[i]>0) break;
					if (plateau[i]<0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==-3 || plateau[i]==-5) return true;		
						return false;
					}
				}
				if (i>=0 && plateau[i]<0 && mod8[i]!=0) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==-3 || plateau[i]==-5) return true;		
					return false;
				}
			}
		}
	}
	plateau.ghostUndoW(cp);
	return false;
}

// effectue une verification d'echec sur un coup potentiel, roi pas en echec avant le coup, cp != coup de roi
bool underCheckB(Coup& cp) { 
	plateau.ghostMoveB(cp); 
	int i;

	// => il suffit de verifier si la piece jouee ne decouvre pas une attaque de fou, tour ou dame

	if (mod8[cp.dep]!=mod8[cp.arr]) {
		if (div8[cp.dep]!=div8[cp.arr]) {
			// check si le roi etait sur la meme colonne
			if (mod8[plateau.roiN]==mod8[cp.dep]) {
				// roi derriere la piece
				if (plateau.roiN<cp.dep) {
					for (i=plateau.roiN+8; i<64; i+=8) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
				// roi devant la piece
				else {
					for (i=plateau.roiN-8; i>=0; i-=8) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
			}
			// puis sur la mme rangee
			else if (div8[plateau.roiN]==div8[cp.dep]) {
				// roi a gauche de la piece
				if (plateau.roiN<cp.dep) {
					for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
				// roi a droite la piece
				else {
					for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
			}
			// enfin, sur la meme diagonale
			else if (div8[plateau.roiN]-div8[cp.dep]==mod8[plateau.roiN]-mod8[cp.dep]) {
				if (div8[cp.dep]-div8[cp.arr]!=mod8[cp.dep]-mod8[cp.arr]) {
					// roi a gauche de la piece
					if (plateau.roiN<cp.dep) {
						for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								plateau.ghostUndoB(cp);
								if (plateau[i]==3 || plateau[i]==5) return true;		
								return false;
							}
						}
						if (i<64 && plateau[i]>0 && mod8[i]!=0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					// roi a droite la piece
					else {
						// check diago
						for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								plateau.ghostUndoB(cp);
								if (plateau[i]==3 || plateau[i]==5) return true;		
								return false;
							}
						}
						if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
			}
			else if (div8[plateau.roiN]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiN]) {
				if (div8[cp.dep]-div8[cp.arr]!=mod8[cp.arr]-mod8[cp.dep]) {
					// roi a droite de la piece
					if (plateau.roiN<cp.dep) {
						for (i=plateau.roiN+7; i<64 && mod8[i]>0; i+=7) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								plateau.ghostUndoB(cp);
								if (plateau[i]==3 || plateau[i]==5) return true;		
								return false;
							}
						}
						if (i<64 && plateau[i]>0 && mod8[i]!=7) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					// roi a gauche de la piece
					else { 
						// check diago
						for (i=plateau.roiN-7; i>=0 && mod8[i]<7; i-=7) {
							if (plateau[i]<0) break;
							if (plateau[i]>0) {
								plateau.ghostUndoB(cp);
								if (plateau[i]==3 || plateau[i]==5) return true;		
								return false;
							}
						}
						if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
							plateau.ghostUndoW(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
			}
		}
		else {
			// check si le roi etait sur la meme colonne
			if (mod8[plateau.roiN]==mod8[cp.dep]) {
				// roi derriere la piece
				if (plateau.roiN<cp.dep) {
					for (i=plateau.roiN+8; i<64; i+=8) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
				// roi devant la piece
				else {
					// check colonne
					for (i=plateau.roiN-8; i>=0; i-=8) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==4 || plateau[i]==5) return true;		
							return false;
						}
					}
				}
			}
			// puis sur la meme diagonale
			else if (div8[plateau.roiN]-div8[cp.dep]==mod8[plateau.roiN]-mod8[cp.dep]) {
				// roi a gauche de la piece
				if (plateau.roiN<cp.dep) {
					for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					if (i<64 && plateau[i]>0 && mod8[i]!=0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				// roi a droite la piece
				else {
					// check diago
					for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
			}
			else if (div8[plateau.roiN]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiN]) {
				// roi a droite de la piece
				if (plateau.roiN<cp.dep) {
					for (i=plateau.roiN+7; i<64 && mod8[i]>0; i+=7) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					if (i<64 && plateau[i]>0 && mod8[i]!=7) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				// roi a droite la piece
				else {
					// check diago
					for (i=plateau.roiN-7; i>=0 && mod8[i]<7; i-=7) {
						if (plateau[i]<0) break;
						if (plateau[i]>0) {
							plateau.ghostUndoB(cp);
							if (plateau[i]==3 || plateau[i]==5) return true;		
							return false;
						}
					}
					if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
						plateau.ghostUndoW(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
			}
		}
	}
	else {
		// check si le roi etait sur la mme rangee
		if (div8[plateau.roiN]==div8[cp.dep]) {
			// roi a gauche de la piece
			if (plateau.roiN<cp.dep) {
				for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==4 || plateau[i]==5) return true;		
						return false;
					}
				}
			}
			// roi a droite la piece
			else {
				// check rangee
				for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==4 || plateau[i]==5) return true;		
						return false;
					}
				}
			}
		}
		// puis sur la meme diagonale
		else if (div8[plateau.roiN]-div8[cp.dep]==mod8[plateau.roiN]-mod8[cp.dep]) {
			// roi a gauche de la piece
			if (plateau.roiN<cp.dep) {
				for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=0) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==3 || plateau[i]==5) return true;		
					return false;
				}
			}
			// roi a droite la piece
			else {
				// check diago
				for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=7) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==3 || plateau[i]==5) return true;		
					return false;
				}
			}
		}
		else if (div8[plateau.roiN]-div8[cp.dep]==mod8[cp.dep]-mod8[plateau.roiN]) {
			// roi a droite de la piece
			if (plateau.roiN<cp.dep) {
				// check diago
				for (i=plateau.roiN+7; i<64 && mod8[i]>0; i+=7) {
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				if (i<64 && plateau[i]>0 && mod8[i]!=7) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==3 || plateau[i]==5) return true;		
					return false;
				}
			}
			// roi a gauche la piece
			else { 
				// check diago
				for (i=plateau.roiN-7; i>=0 && mod8[i]<7; i-=7) { 
					if (plateau[i]<0) break;
					if (plateau[i]>0) {
						plateau.ghostUndoB(cp);
						if (plateau[i]==3 || plateau[i]==5) return true;		
						return false;
					}
				}
				if (i>=0 && plateau[i]>0 && mod8[i]!=0) {
					plateau.ghostUndoW(cp);
					if (plateau[i]==3 || plateau[i]==5) return true;		
					return false;
				}
			}
		}
	}
	plateau.ghostUndoB(cp);
	return false;
}

// effectue une verification d'echec sur un coup potentiel, roi eventuellement en echec avant le coup, 
bool underCheckW_K(Coup& cp) { 	
	// coup de roi: il faut tout regarder ! heureusement ils sont minoritaires
	plateau.ghostMoveKW(cp); 
	int i;

	if (plateau.roiB==0) {
		if (plateau[17]==-2 || plateau[10]==-2 || plateau[9]==-1) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=1; i<8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break; 
			}
		}
		for (i=9; i<64; i+=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				} 
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (plateau.roiB==7) {
		if (plateau[22]==-2 || plateau[13]==-2 || plateau[14]==-1) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=6; i>=0; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=15; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=14; i<63; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (plateau.roiB<8) { 
		if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+9]==-1 || plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB+9]==-6 
			|| plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB+15]==-2 
			|| plateau[plateau.roiB+17]==-2 || (plateau.roiB>1 && plateau[plateau.roiB+6]==-2) || (plateau.roiB<6 && plateau[plateau.roiB+10]==-2)) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=plateau.roiB-1; i>=0; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp); 
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+1; i<8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) { 
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	} 
	if (plateau.roiB==56) {
		if (plateau[41]==-2 || plateau[50]==-2) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=57; i<64; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=48; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=49; i>=7; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (mod8[plateau.roiB]==0) {
		if (plateau[plateau.roiB+9]==-1 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+9]==-6 || plateau[plateau.roiB+1]==-6
			|| plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB+10]==-2 || plateau[plateau.roiB-6]==-2
			|| (plateau.roiB<48 && plateau[plateau.roiB+17]==-2) || (plateau.roiB>8 && plateau[plateau.roiB-15]==-2)) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=plateau.roiB+1; i<plateau.roiB+8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+9; i<64; i+=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-7; i>=0; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (plateau.roiB==63) {
		if (plateau[46]==-2 || plateau[53]==-2) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=62; i>=56; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=55; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=54; i>=0; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (mod8[plateau.roiB]==7) {
		if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB-1]==-6
			|| plateau[plateau.roiB-9]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB+6]==-2 || plateau[plateau.roiB-10]==-2
			|| (plateau.roiB<48 && plateau[plateau.roiB+15]==-2) || (plateau.roiB>8 && plateau[plateau.roiB-17]==-2)) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=plateau.roiB-1; i>=plateau.roiB-7; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+7; i<64; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-9; i>=0; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	if (plateau.roiB>=56) {
		if (plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB-9]==-6 || plateau[plateau.roiB-8]==-6
			|| plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB-15]==-2 || plateau[plateau.roiB-17]==-2
			|| (plateau.roiB>57 && plateau[plateau.roiB-10]==-2) || (plateau.roiB<62 && plateau[plateau.roiB-6]==-2)) {
			plateau.ghostUndoKW(cp);
			return true;
		}
		for (i=plateau.roiB-1; i>=56; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB+1; i<64; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) {
					plateau.ghostUndoKW(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKW(cp);
		return false;
	}
	// centre
	int reste=mod8[plateau.roiB];
	if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+9]==-1
		|| plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+9]==-6 
		|| plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB-9]==-6
		|| (reste>1 && (plateau[plateau.roiB+6]==-2 || plateau[plateau.roiB-10]==-2)) 
		|| (reste<6 && (plateau[plateau.roiB+10]==-2 || plateau[plateau.roiB-6]==-2)) 
		|| (plateau.roiB<48 && (plateau[plateau.roiB+15]==-2 || plateau[plateau.roiB+17]==-2)) 
		|| (plateau.roiB>=16 && (plateau[plateau.roiB-15]==-2 || plateau[plateau.roiB-17]==-2))) {
		plateau.ghostUndoKW(cp);
		return true;
	}
	for (i=plateau.roiB-1; i>=plateau.roiB-reste; i--) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB+1; i<plateau.roiB+8-reste; i++) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB+8; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB-8; i>=0; i-=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) {
				plateau.ghostUndoKW(cp);
				return true;
			}
			break;
		}
	}
	plateau.ghostUndoKW(cp);
	return false;
}
  
// effectue une verification d'echec sur un coup quelconque 	
bool underCheckB_K(Coup& cp) { 
	// il faut tout regarder ! heureusement ces coups sont minoritaires
	plateau.ghostMoveKB(cp); 
	int i;
		
	if (plateau.roiN==56) {
		if (plateau[41]==2 || plateau[50]==2 || plateau[49]==1) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=57; i<64; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=48; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=49; i>=7; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (plateau.roiN==63) {
		if (plateau[46]==2 || plateau[53]==2 || plateau[54]==1) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=62; i>=56; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=55; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=54; i>=0; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (plateau.roiN>=56) {
		if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN-9]==1 || plateau[plateau.roiN-1]==6 || plateau[plateau.roiN-9]==6 || plateau[plateau.roiN-8]==6
			|| plateau[plateau.roiN-7]==6 || plateau[plateau.roiN+1]==6 || plateau[plateau.roiN-15]==2 || plateau[plateau.roiN-17]==2
			|| (plateau.roiN>57 && plateau[plateau.roiN-10]==2) || (plateau.roiN<62 && plateau[plateau.roiN-6]==2)) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=plateau.roiN-1; i>=56; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+1; i<64; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (plateau.roiN==0) {
		if (plateau[17]==2 || plateau[10]==2) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=1; i<8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break; 
			}
		}
		for (i=9; i<64; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				} 
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (mod8[plateau.roiN]==0) {
		if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+9]==6 || plateau[plateau.roiN+1]==6
			|| plateau[plateau.roiN-7]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN+10]==2 || plateau[plateau.roiN-6]==2
			|| (plateau.roiN<48 && plateau[plateau.roiN+17]==2) || (plateau.roiN>8 && plateau[plateau.roiN-15]==2)) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=plateau.roiN+1; i<plateau.roiN+8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+9; i<64; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-7; i>=0; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (plateau.roiN==7) {
		if (plateau[22]==2 || plateau[13]==2) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=6; i>=0; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=15; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=14; i<63; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (mod8[plateau.roiN]==7) {
		if (plateau[plateau.roiN-9]==1 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN-1]==6
			|| plateau[plateau.roiN-9]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN+6]==2 || plateau[plateau.roiN-10]==2
			|| (plateau.roiN<48 && plateau[plateau.roiN+15]==2) || (plateau.roiN>8 && plateau[plateau.roiN-17]==2)) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=plateau.roiN-1; i>=plateau.roiN-7; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+7; i<64; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN-9; i>=0; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	}
	if (plateau.roiN<8) { 
		if (plateau[plateau.roiN-1]==6 || plateau[plateau.roiN+9]==6 
			|| plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN+1]==6 || plateau[plateau.roiN+15]==2 
			|| plateau[plateau.roiN+17]==2 || (plateau.roiN>1 && plateau[plateau.roiN+6]==2) || (plateau.roiN<6 && plateau[plateau.roiN+10]==2)) {
			plateau.ghostUndoKB(cp);
			return true;
		}
		for (i=plateau.roiN-1; i>=0; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp); 
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+1; i<8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) { 
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) {
					plateau.ghostUndoKB(cp);
					return true;
				}
				break;
			}
		}
		plateau.ghostUndoKB(cp);
		return false;
	} 
	// centre
	int reste=mod8[plateau.roiN];
	if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN-9]==1
		|| plateau[plateau.roiN-1]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+9]==6 
		|| plateau[plateau.roiN+1]==6 || plateau[plateau.roiN-7]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN-9]==6
		|| (reste>1 && (plateau[plateau.roiN+6]==2 || plateau[plateau.roiN-10]==2)) 
		|| (reste<6 && (plateau[plateau.roiN+10]==2 || plateau[plateau.roiN-6]==2)) 
		|| (plateau.roiN<48 && (plateau[plateau.roiN+15]==2 || plateau[plateau.roiN+17]==2)) 
		|| (plateau.roiN>=16 && (plateau[plateau.roiN-15]==2 || plateau[plateau.roiN-17]==2))) {
		plateau.ghostUndoKB(cp);
		return true;
	}
	for (i=plateau.roiN-1; i>=plateau.roiN-reste; i--) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN+1; i<plateau.roiN+8-reste; i++) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN+8; i<64; i+=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN-8; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) {
				plateau.ghostUndoKB(cp);
				return true;
			}
			break;
		}
	}
	plateau.ghostUndoKB(cp);
	return false;
}

// effectue une verification d'echec sur un coup quelconque
bool underCheckWM_W() { 	
	int i;

	if (plateau.roiB==0) {
		if (plateau[17]==-2 || plateau[10]==-2 || plateau[9]==-1) return true;
		for (i=1; i<8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break; 
			}
		}
		for (i=9; i<64; i+=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiB==7) {
		if (plateau[22]==-2 || plateau[13]==-2 || plateau[14]==-1) return true;
		for (i=6; i>=0; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=15; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=14; i<63; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiB<8) { 
		if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+9]==-1 || plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB+9]==-6 
			|| plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB+15]==-2 
			|| plateau[plateau.roiB+17]==-2 || (plateau.roiB>1 && plateau[plateau.roiB+6]==-2) || (plateau.roiB<6 && plateau[plateau.roiB+10]==-2))
			return true;
		for (i=plateau.roiB-1; i>=0; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+1; i<8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) { 
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	} 
	if (plateau.roiB==56) {
		if (plateau[41]==-2 || plateau[50]==-2) return true;
		for (i=57; i<64; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=48; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=49; i>=7; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (mod8[plateau.roiB]==0) {
		if (plateau[plateau.roiB+9]==-1 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+9]==-6 || plateau[plateau.roiB+1]==-6
			|| plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB+10]==-2 || plateau[plateau.roiB-6]==-2
			|| (plateau.roiB<48 && plateau[plateau.roiB+17]==-2) || (plateau.roiB>8 && plateau[plateau.roiB-15]==-2))
			return true;
		for (i=plateau.roiB+1; i<plateau.roiB+8; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+9; i<64; i+=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-7; i>=0; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiB==63) {
		if (plateau[46]==-2 || plateau[53]==-2) return true;
		for (i=62; i>=56; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=55; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=54; i>=0; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (mod8[plateau.roiB]==7) {
		if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB-1]==-6
			|| plateau[plateau.roiB-9]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB+6]==-2 || plateau[plateau.roiB-10]==-2
			|| (plateau.roiB<48 && plateau[plateau.roiB+15]==-2) || (plateau.roiB>8 && plateau[plateau.roiB-17]==-2))
			return true;
		for (i=plateau.roiB-1; i>=plateau.roiB-7; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+8; i<64; i+=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+7; i<64; i+=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-9; i>=0; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiB>=56) {
		if (plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB-9]==-6 || plateau[plateau.roiB-8]==-6
			|| plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB-15]==-2 || plateau[plateau.roiB-17]==-2
			|| (plateau.roiB>57 && plateau[plateau.roiB-10]==-2) || (plateau.roiB<62 && plateau[plateau.roiB-6]==-2))
			return true;
		for (i=plateau.roiB-1; i>=56; i--) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB+1; i<64; i++) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-8; i>=0; i-=8) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-4 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
			if (plateau[i]>0) break;
			if (plateau[i]<0) {
				if (plateau[i]==-3 || plateau[i]==-5) return true;
				break;
			}
		}
		return false;
	}
	// centre
	if (plateau[plateau.roiB+7]==-1 || plateau[plateau.roiB+9]==-1
		|| plateau[plateau.roiB-1]==-6 || plateau[plateau.roiB+7]==-6 || plateau[plateau.roiB+8]==-6 || plateau[plateau.roiB+9]==-6 
		|| plateau[plateau.roiB+1]==-6 || plateau[plateau.roiB-7]==-6 || plateau[plateau.roiB-8]==-6 || plateau[plateau.roiB-9]==-6
		|| (mod8[plateau.roiB]>1 && (plateau[plateau.roiB+6]==-2 || plateau[plateau.roiB-10]==-2)) 
		|| (mod8[plateau.roiB]<6 && (plateau[plateau.roiB+10]==-2 || plateau[plateau.roiB-6]==-2)) 
		|| (plateau.roiB<48 && (plateau[plateau.roiB+15]==-2 || plateau[plateau.roiB+17]==-2)) 
		|| (plateau.roiB>=16 && (plateau[plateau.roiB-15]==-2 || plateau[plateau.roiB-17]==-2)))
		return true;
	for (i=plateau.roiB-1; i>=plateau.roiB-mod8[plateau.roiB]; i--) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB+1; i<plateau.roiB+8-mod8[plateau.roiB]; i++) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB+8; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB-8; i>=0; i-=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=plateau.roiB-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	return false;
}
  
// effectue une verification d'echec sur un coup quelconque 	
bool underCheckWM_B() {
	int i;
		
	if (plateau.roiN==56) {
		if (plateau[41]==2 || plateau[50]==2 || plateau[49]==1) return true;
		for (i=57; i<64; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=48; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=49; i>=7; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiN==63) {
		if (plateau[46]==2 || plateau[53]==2 || plateau[54]==1) return true;
		for (i=62; i>=56; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=55; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=54; i>=0; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiN>=56) {
		if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN-9]==1 || plateau[plateau.roiN-1]==6 || plateau[plateau.roiN-9]==6 || plateau[plateau.roiN-8]==6
			|| plateau[plateau.roiN-7]==6 || plateau[plateau.roiN+1]==6 || plateau[plateau.roiN-15]==2 || plateau[plateau.roiN-17]==2
			|| (plateau.roiN>57 && plateau[plateau.roiN-10]==2) || (plateau.roiN<62 && plateau[plateau.roiN-6]==2))
			return true;
		for (i=plateau.roiN-1; i>=56; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+1; i<64; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiN==0) {
		if (plateau[17]==2 || plateau[10]==2) return true;
		for (i=1; i<8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break; 
			}
		}
		for (i=9; i<64; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (mod8[plateau.roiN]==0) {
		if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+9]==6 || plateau[plateau.roiN+1]==6
			|| plateau[plateau.roiN-7]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN+10]==2 || plateau[plateau.roiN-6]==2
			|| (plateau.roiN<48 && plateau[plateau.roiN+17]==2) || (plateau.roiN>8 && plateau[plateau.roiN-15]==2))
			return true;
		for (i=plateau.roiN+1; i<plateau.roiN+8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+9; i<64; i+=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-7; i>=0; i-=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiN==7) {
		if (plateau[22]==2 || plateau[13]==2) return true;
		for (i=6; i>=0; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=15; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=14; i<63; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (mod8[plateau.roiN]==7) {
		if (plateau[plateau.roiN-9]==1 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN-1]==6
			|| plateau[plateau.roiN-9]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN+6]==2 || plateau[plateau.roiN-10]==2
			|| (plateau.roiN<48 && plateau[plateau.roiN+15]==2) || (plateau.roiN>8 && plateau[plateau.roiN-17]==2))
			return true;
		for (i=plateau.roiN-1; i>=plateau.roiN-7; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-8; i>=0; i-=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+7; i<64; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN-9; i>=0; i-=9) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	}
	if (plateau.roiN<8) { 
		if (plateau[plateau.roiN-1]==6 || plateau[plateau.roiN+9]==6 
			|| plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN+1]==6 || plateau[plateau.roiN+15]==2 
			|| plateau[plateau.roiN+17]==2 || (plateau.roiN>1 && plateau[plateau.roiN+6]==2) || (plateau.roiN<6 && plateau[plateau.roiN+10]==2))
			return true;
		for (i=plateau.roiN-1; i>=0; i--) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+1; i<8; i++) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+8; i<64; i+=8) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==4 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) { 
			if (plateau[i]<0) break;
			if (plateau[i]>0) {
				if (plateau[i]==3 || plateau[i]==5) return true;
				break;
			}
		}
		return false;
	} 
	// centre
	if (plateau[plateau.roiN-7]==1 || plateau[plateau.roiN-9]==1
		|| plateau[plateau.roiN-1]==6 || plateau[plateau.roiN+7]==6 || plateau[plateau.roiN+8]==6 || plateau[plateau.roiN+9]==6 
		|| plateau[plateau.roiN+1]==6 || plateau[plateau.roiN-7]==6 || plateau[plateau.roiN-8]==6 || plateau[plateau.roiN-9]==6
		|| (mod8[plateau.roiN]>1 && (plateau[plateau.roiN+6]==2 || plateau[plateau.roiN-10]==2)) 
		|| (mod8[plateau.roiN]<6 && (plateau[plateau.roiN+10]==2 || plateau[plateau.roiN-6]==2)) 
		|| (plateau.roiN<48 && (plateau[plateau.roiN+15]==2 || plateau[plateau.roiN+17]==2)) 
		|| (plateau.roiN>=16 && (plateau[plateau.roiN-15]==2 || plateau[plateau.roiN-17]==2)))
		return true;
	for (i=plateau.roiN-1; i>=plateau.roiN-mod8[plateau.roiN]; i--) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN+1; i<plateau.roiN+8-mod8[plateau.roiN]; i++) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN+8; i<64; i+=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN-8; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN+7; i<64 && mod8[i]<7; i+=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN-7; i>=0 && mod8[i]>0; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN+9; i<64 && mod8[i]>0; i+=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=plateau.roiN-9; i>=0 && mod8[i]<7; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	return false;
}
 
// version sans effectuer de coup (5 cases pr chaque camp)
bool underCheck_4() { 
	int i;
	// parcours pour determiner si le roi est attaque
	if (plateau[11]==-1 || plateau[13]==-1 || plateau[19]==-2 
		|| plateau[21]==-2 || plateau[10]==-2 || plateau[14]==-2) return true;
	for (i=3; i>=0; i--) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=12; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=11; i<=32; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=13; i<=31; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_5() { 
	int i;
	if (plateau[12]==-1 || plateau[14]==-1 || plateau[20]==-2 
		|| plateau[22]==-2 || plateau[11]==-2 || plateau[15]==-2) return true;
	for (i=13; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=12; i<=40; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=14; i<=23; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_6() { 
	int i;
	if (plateau[15]==-1 || plateau[23]==-2 || plateau[12]==-2) return true;
	for (i=14; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=13; i<=48; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	if (plateau[15]<0) {
		if (plateau[15]==-3 || plateau[15]==-5) return true;
	}
	return false;
}
bool underCheck_3() { 
	int i;
	if (plateau[10]==-1 || plateau[12]==-1 || plateau[18]==-2 
		|| plateau[20]==-2 || plateau[9]==-2 || plateau[13]==-2) return true;
	for (i=11; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=10; i<=24; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=12; i<=39; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_2() { 
	int i;
	if (plateau[9]==-1 || plateau[17]==-2 || plateau[8]==-2 || plateau[12]==-2) return true;
	for (i=10; i<64; i+=8) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-4 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=9; i<=16; i+=7) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	for (i=11; i<=47; i+=9) {
		if (plateau[i]>0) break;
		if (plateau[i]<0) {
			if (plateau[i]==-3 || plateau[i]==-5) return true;
			break;
		}
	}
	return false;
}

// pour le roque
bool underCheck_60() {
	int i;
	if (plateau[53]==1 || plateau[51]==1 || plateau[45]==2 
		|| plateau[43]==2 || plateau[50]==2 || plateau[54]==2) return true;
	for (i=59; i>=56; i--) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=52; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=53; i>=39; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=51; i>=24; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_61() {
	int i;
	if (plateau[54]==1 || plateau[52]==1 || plateau[46]==2 
		|| plateau[44]==2 || plateau[51]==2 || plateau[55]==2) return true;
	for (i=53; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=54; i>=47; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=52; i>=16; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_62() {
	int i;
	if (plateau[55]==1 || plateau[47]==2 || plateau[52]==2) return true;
	for (i=54; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=53; i>=8; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	if (plateau[55]>0) {
		if (plateau[55]==3 || plateau[55]==5) return true;
	}
	return false;
}
bool underCheck_59() { 
	int i;
	if (plateau[52]==1 || plateau[50]==1 || plateau[44]==2 
		|| plateau[42]==2 || plateau[49]==2 || plateau[53]==2) return true;
	for (i=51; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=52; i>=31; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=50; i>=32; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	return false;
}
bool underCheck_58() { 
	int i;
	if (plateau[49]==1 || plateau[41]==2 || plateau[48]==2 || plateau[52]==2) return true;
	for (i=50; i>=0; i-=8) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==4 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=51; i>=23; i-=7) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	for (i=49; i>=40; i-=9) {
		if (plateau[i]<0) break;
		if (plateau[i]>0) {
			if (plateau[i]==3 || plateau[i]==5) return true;
			break;
		}
	}
	return false;
}
