/* 
* vecteur light: pas de verifications d'alloc/dealloc, copie des elements
*/

#ifndef _VectorInt
#define _VectorInt

#include <cstdlib>

class VectorInt {

public:

	VectorInt() {
		currSize=0;
		allocSize=0;
		vect=0;
	}

	int size() const {
		return currSize;
	}
	bool empty() const {
		return (currSize<=0);
	}

	int& operator[](int n) {
		return *(vect+n);
	}
	const int& operator[](int n) const {
		return *(vect+n);
	}

	void push_back(int s) {
		if (currSize<allocSize)
			vect[currSize++]=s;
		else {
			/* on double la taille du vecteur */
			allocSize=2*allocSize+1;
			if (currSize>0) {
				int* aux=vect;
				vect=(int*)malloc(allocSize*sizeof(int));
				for (int i=currSize-1; i>=0; i--) vect[i]=aux[i];
				free(aux);
			}
			else vect=(int*)malloc(allocSize*sizeof(int));
			vect[currSize++]=s;
		}
		return;
	}

	void clear() {
		currSize=0;
		return;
	}

	~VectorInt() {
		if (vect!=0) free(vect);
	}

private:

	unsigned int currSize,allocSize;
	int* vect;
	
};

#endif
