/* 
* vecteur light: pas de verifications d'alloc/dealloc, copie des elements
*/

#ifndef _VectorMoves
#define _VectorMoves

#include "Coup.h"
#include <cstdlib>

class VectorMoves {

public:

	VectorMoves() {
		currSize=0;
	}

	void init() {
		/* initialisation avec taille "inatteignable"; realise qu'une fois */
		vect=new Coup[128];
	}

	int size() const {
		return currSize;
	}
	bool empty() const {
		return (currSize<=0);
	}

	Coup& operator[](int n) {
		return vect[n];
	}
	const Coup& operator[](int n) const {
		return vect[n];
	}

	/* un meme objet appelle une et une seule des deux fonctions suivantes */
	void copie(const VectorMoves& vt) {
		currSize=vt.size();
		vect=new Coup[currSize];
		for (int i=currSize-1; i>=0; i--) {
			vect[i].dep=vt[i].dep;
			vect[i].arr=vt[i].arr;
			vect[i].prb=vt[i].prb;
			vect[i].prn=vt[i].prn;
			vect[i].grb=vt[i].grb;
			vect[i].grn=vt[i].grn;
			vect[i].enPassant=vt[i].enPassant;
			vect[i].roque=vt[i].roque;
			vect[i].promotion=vt[i].promotion;
		}
		return;
	}
	void push_back(const Coup& cp) {
		vect[currSize].dep=cp.dep;
		vect[currSize].arr=cp.arr;
		vect[currSize].prb=cp.prb;
		vect[currSize].prn=cp.prn;
		vect[currSize].grb=cp.grb;
		vect[currSize].grn=cp.grn;
		vect[currSize].enPassant=cp.enPassant;
		vect[currSize].roque=cp.roque;
		vect[currSize++].promotion=cp.promotion;
		return;
	}

	void clear() {
		currSize=0;
		return;
	}
	
	~VectorMoves() {
		delete [] vect;
	}

private:

	unsigned int currSize;
	Coup* vect;
	
};

#endif
