/* 
* vecteur light: pas de verifications d'alloc/dealloc, pas de copie des elements
*/

#ifndef _VectorSignEval
#define _VectorSignEval

#include "Plateau.h"
#include <cstdlib>

class VectorSignEval {

public:

	VectorSignEval() {
		currSize=0;
		allocSize=0;
		vect=0;
	}

	int size() const {
		return currSize;
	}
	bool empty() const {
		return (currSize<=0);
	}

	SignEval& operator[](int n) {
		return vect[n];
	}
	const SignEval& operator[](int n) const {
		return vect[n];
	}

	void push_back(int pf,float ev,unsigned long long cle) {
		if (currSize<allocSize)
			vect[currSize++]=SignEval(pf,ev,cle);
		else {
			/* on double la taille du vecteur */
			allocSize=2*allocSize+1;
			if (currSize>0) {
				SignEval* aux=vect;
				vect=new SignEval[allocSize];
				for (int i=currSize-1; i>=0; i--) {
					vect[i].prof=aux[i].prof;
					vect[i].eval=aux[i].eval;
					vect[i].clef=aux[i].clef;
				}
				delete [] aux;
			}
			else vect=new SignEval[allocSize];
			vect[currSize].prof=pf;
			vect[currSize].eval=ev;
			vect[currSize++].clef=cle;
		}
		return;
	}
	
	~VectorSignEval() {
		delete [] vect;
	}

private:

	unsigned int currSize,allocSize;
	SignEval* vect;
	
};

#endif
